

BPB_SEG    equ  07E0h    ; BPB at 0x07E00
FAT_SEG    equ  0800h    ; FAT at 0x08000
ROOT_SEG   equ  1000h    ; ROOT at 0x10000
FILE_SEG   equ  3000h    ; load kernel file to 0x30000


S_PART_ENTRY  struct
  boot_id     byte     ; id
  s_head      byte     ;
  s_sector    byte     ; hi 2 bits = hi 2 bits of cyl, low 6 bits = sector
  s_cylinder  byte     ; low 8 bits of 10 bit cyl
  sys_id      byte     ; sys id
  e_head      byte     ;
  e_sector    byte     ; hi 2 bits = hi 2 bits of cyl, low 6 bits = sector
  e_cylinder  byte     ; low 8 bits of 10 bit cyl  bit32u start_lba;
  start       dword    ; starting LBA
  size        dword    ; size in sectors
S_PART_ENTRY  ends

S_FAT1216_BPB struct
	jump           dup 3 ;
	oem_name       dup 8 ; oem name
	bytes_per_sect word  ;
	sect_per_clust byte  ;
	sect_reserved  word  ;
	fats           byte  ;
	root_entrys    word  ;
	sectors        word  ;
	descriptor     byte  ;
	sect_per_fat   word  ;
	sect_per_trk   word  ;
	heads          word  ;
	hidden_sects  dword  ;
	sect_extnd    dword  ;
	drive_num      byte  ;
	resv           byte  ;
	sig            byte  ;
	serial        dword  ;
	label         dup 11 ;
	sys_type      dup 8  ;
S_FAT1216_BPB ends


S_FAT_ROOT    struct
	name        dup 8  ; name
	ext         dup 3  ; ext
	attrb       byte   ; attribute
	resv        dup 10 ; reserved in fat12/16
	time        word   ; time
	date        word   ; date
	strtclst    word   ; starting cluster number
	filesize   dword   ; file size in bytes
S_FAT_ROOT    ends


.end
